<?php

namespace seraph_accel;

if( !defined( 'ABSPATH' ) )
	exit;

function _Scripts_EncodeBodyAsSrc( $cont )
{

	$cont = str_replace( "%", '%25', $cont );

	$cont = str_replace( "\n", '%0A', $cont );
	$cont = str_replace( "#", '%23', $cont );
	$cont = str_replace( "\"", '%22', $cont );

	return( $cont );
}

function IsScriptTypeJs( $type )
{
	return( !$type || $type == 'application/javascript' || $type == 'text/javascript' || $type == 'module' );
}

function Script_SrcAddPreloading( $item, $src, $head, $doc )
{
	if( !$src )
		return;

	$itemPr = $doc -> createElement( 'link' );
	$itemPr -> setAttribute( 'rel', 'preload' );
	$itemPr -> setAttribute( 'as', $item -> tagName == 'IFRAME' ? 'document' : 'script' );
	$itemPr -> setAttribute( 'href', $src );
	if( $item -> hasAttribute( 'integrity' ) )
		$itemPr -> setAttribute( "integrity", $item -> getAttribute( "integrity" ) );
	if( $item -> hasAttribute( "crossorigin" ) )
		$itemPr -> setAttribute( "crossorigin", $item -> getAttribute( "crossorigin" ) );
	$head -> appendChild( $itemPr );
}

function Scripts_Process( &$ctxProcess, $sett, $settCache, $settContPr, $settJs, $settCdn, $doc )
{
	if( (isset($ctxProcess[ 'isAMP' ])?$ctxProcess[ 'isAMP' ]:null) )
	    return( true );

	$optLoad = Gen::GetArrField( $settJs, array( 'optLoad' ), false );
	$skips = Gen::GetArrField( $settJs, array( 'skips' ), array() );

	if( !( $optLoad || Gen::GetArrField( $settJs, array( 'groupNonCrit' ), false ) || Gen::GetArrField( $settJs, array( 'min' ), false ) || Gen::GetArrField( $settCdn, array( 'enable' ), false ) || $skips ) )
		return( true );

	if( (isset($ctxProcess[ 'compatView' ])?$ctxProcess[ 'compatView' ]:null) )
		$optLoad = false;

	$notCritsDelayTimeout = Gen::GetArrField( $settJs, array( 'nonCrit', 'timeout', 'enable' ), false ) ? Gen::GetArrField( $settJs, array( 'nonCrit', 'timeout', 'v' ), 0 ) : null;

	$specsDelayTimeout = Gen::GetArrField( $settJs, array( 'spec', 'timeout', 'enable' ), false ) ? Gen::GetArrField( $settJs, array( 'spec', 'timeout', 'v' ), 0 ) : null;
	$specs = ( ( $notCritsDelayTimeout !== null && $specsDelayTimeout ) || ( $notCritsDelayTimeout === null && $specsDelayTimeout !== null ) ) ? Gen::GetArrField( $settJs, array( 'spec', 'items' ), array() ) : array();

	$head = $ctxProcess[ 'ndHead' ];
	$body = $ctxProcess[ 'ndBody' ];

	$settNonCrit = Gen::GetArrField( $settJs, array( 'nonCrit' ), array() );

	$delayNotCritNeeded = false;
	$delaySpecNeeded = false;

	$items = HtmlNd::ChildrenAsArr( $doc -> getElementsByTagName( 'script' ) );

	$contGroups = array( 'crit' => array( 0, '' ), '' => array( 0, '' ), 'spec' => array( 0, '' ) );

	foreach( $items as $item )
	{
		if( ContentProcess_IsAborted() ) return( true );

		$type = HtmlNd::GetAttrVal( $item, 'type' );
		if( !IsScriptTypeJs( $type ) )
			continue;

		if( apply_filters( 'seraph_accel_jscss_addtype', false ) )
		{
			if( !$type )
				$item -> setAttribute( 'type', $type = 'text/javascript' );
		}
		else if( $type && (isset($settContPr[ 'min' ])?$settContPr[ 'min' ]:null) && $type != 'module' )
		{
			$item -> removeAttribute( 'type' );
			$type = null;
		}

		$src = HtmlNd::GetAttrVal( $item, 'src' );
		$id = HtmlNd::GetAttrVal( $item, 'id' );
		$cont = $item -> nodeValue;

		{

		}

		$detectedPattern = null;
		if( IsObjInRegexpList( $skips, $src, $id, $cont, $detectedPattern ) )
		{
			if( (isset($ctxProcess[ 'debug' ])?$ctxProcess[ 'debug' ]:null) )
			{
				$item -> setAttribute( 'type', 'o/js-inactive' );
				$item -> setAttribute( 'seraph-accel-debug', 'status=skipped;' . ( $detectedPattern ? ' detectedPattern="' . $detectedPattern . '"' : '' ) );
			}
			else
				$item -> parentNode -> removeChild( $item );
			continue;
		}

		$detectedPattern = null;
		if( $src )
		{
			$srcInfo = GetSrcAttrInfo( $ctxProcess, null, null, $src );

			if( (isset($srcInfo[ 'filePath' ])?$srcInfo[ 'filePath' ]:null) )
				$cont = @file_get_contents( $srcInfo[ 'filePath' ] );
			if( !$cont )
				$cont = GetExtContents( (isset($srcInfo[ 'url' ])?$srcInfo[ 'url' ]:null) );

			$isCrit = $item -> hasAttribute( 'seraph-accel-crit' ) ? true : GetObjSrcCritStatus( $settNonCrit, $specs, $srcInfo, $src, $id, $cont, $detectedPattern );

			if( Script_AdjustCont( $ctxProcess, $settCache, $settJs, $srcInfo, $src, $id, $cont ) )
			{
				if( (isset($ctxProcess[ 'debug' ])?$ctxProcess[ 'debug' ]:null) )
					$cont = '// ################################################################################################################################################' . "\r\n" . '// DEBUG: seraph-accel JS src="' . $src . '"' . "\r\n\r\n" . $cont;

				if( !adkxsshiujqtfk( $ctxProcess, $settCache, 'js', $cont, $src ) )
					return( false );
			}

			Cdn_AdjustUrl( $ctxProcess, $settCdn, $src, 'js' );
			Fullness_AdjustUrl( $ctxProcess, $src, (isset($srcInfo[ 'srcUrlFullness' ])?$srcInfo[ 'srcUrlFullness' ]:null) );

			$item -> setAttribute( 'src', $src );
		}
		else
		{
			if( !$cont )
				continue;

			$isCrit = $item -> hasAttribute( 'seraph-accel-crit' ) ? true : GetObjSrcCritStatus( $settNonCrit, $specs, null, null, $id, $cont, $detectedPattern );

			if( Script_AdjustCont( $ctxProcess, $settCache, $settJs, null, null, $id, $cont ) )
			{
				if( (isset($ctxProcess[ 'debug' ])?$ctxProcess[ 'debug' ]:null) )
					$cont = '// ################################################################################################################################################' . "\r\n" . '// DEBUG: seraph-accel JS src="inline:' . (isset($ctxProcess[ 'serverArgs' ][ 'REQUEST_SCHEME' ])?$ctxProcess[ 'serverArgs' ][ 'REQUEST_SCHEME' ]:null) . '://' . (isset($ctxProcess[ 'serverArgs' ][ 'SERVER_NAME' ])?$ctxProcess[ 'serverArgs' ][ 'SERVER_NAME' ]:null) . ':' . (isset($ctxProcess[ 'serverArgs' ][ 'SERVER_PORT' ])?$ctxProcess[ 'serverArgs' ][ 'SERVER_PORT' ]:null) . (isset($ctxProcess[ 'serverArgs' ][ 'REQUEST_URI' ])?$ctxProcess[ 'serverArgs' ][ 'REQUEST_URI' ]:null) . ':' . $item -> getLineNo() . '"' . "\r\n\r\n" . $cont;

				HtmlNd::SetValFromContent( $item, $cont );
			}
		}

		ContUpdateItemIntegrity( $item, $cont );

		if( (isset($ctxProcess[ 'debug' ])?$ctxProcess[ 'debug' ]:null) )
			$item -> setAttribute( 'seraph-accel-debug', 'status=' . ( $isCrit === true ? 'critical' : ( $isCrit === null ? 'special' : 'nonCritical' ) ) . ';' . ( $detectedPattern ? ' detectedPattern="' . $detectedPattern . '"' : '' ) );

		$delay = 0;
		if( $optLoad )
		{
			if( !$isCrit )
			{
				$parentNode = $item -> parentNode;
				$async = $item -> hasAttribute( 'async' );

				$delay = ( $isCrit === null ) ? $specsDelayTimeout : $notCritsDelayTimeout;

				if( $delay === 0 && ( !$async || ( $parentNode === $head || $parentNode === $body ) ) )
					$body -> appendChild( $item );
			}

		}

		if( (isset($ctxProcess[ 'chunksEnabled' ])?$ctxProcess[ 'chunksEnabled' ]:null) )
			ContentMarkSeparate( $item, false );

		if( $delay )
		{
			if( $type )
				$item -> setAttribute( 'data-type', $type );

			if( $isCrit === null )
			{

				$item -> setAttribute( 'type', 'o/js-lzls' );
				$delaySpecNeeded = true;
			}
			else
			{

				$item -> setAttribute( 'type', 'o/js-lzl' );
				$delayNotCritNeeded = true;
			}
		}

		if( !(isset($ctxProcess[ 'compatView' ])?$ctxProcess[ 'compatView' ]:null) && (isset($settJs[ $isCrit ? 'group' : ( $isCrit === null ? 'groupSpec' : 'groupNonCrit' ) ])?$settJs[ $isCrit ? 'group' : ( $isCrit === null ? 'groupSpec' : 'groupNonCrit' ) ]:null) )
		{
			if( $cont === false )
				$cont = '';

			if( substr( $cont, -1, 1 ) == ';' )
				$cont .= "\r\n";
			else
				$cont .= ";\r\n";

			if( (isset($ctxProcess[ 'chunksEnabled' ])?$ctxProcess[ 'chunksEnabled' ]:null) && Gen::GetArrField( $settCache, array( 'chunks', 'js' ) ) )
				$cont .= ContentMarkGetSep();

			if( $optLoad && $isCrit === false && $delayNotCritNeeded )
				$cont .= 'seraph_accel_gzjydy();';

			$contGroup = &$contGroups[ $isCrit ? 'crit' : ( $isCrit === null ? 'spec' : '' ) ];

			if( $item -> hasAttribute( 'defer' ) )
			{
				$contGroup[ 1 ] .= $cont;
			}
			else
			{
				$contGroup[ 1 ] = substr_replace( $contGroup[ 1 ], $cont, $contGroup[ 0 ], 0 );
				$contGroup[ 0 ] += strlen( $cont );
			}

			unset( $contGroup );

			$item -> parentNode -> removeChild( $item );
		}
		else if( $delay && (isset($settJs[ 'preLoadEarly' ])?$settJs[ 'preLoadEarly' ]:null) )
			Script_SrcAddPreloading( $item, $src, $head, $doc );
	}

	if( $optLoad )
	{
		foreach( HtmlNd::ChildrenAsArr( $doc -> getElementsByTagName( 'iframe' ) ) as $item )
		{
			if( ContentProcess_IsAborted() ) return( true );

			if( HtmlNd::FindUpByTag( $item, 'noscript' ) )
				continue;

			if( !Scripts_IsElemAs( $ctxProcess, $doc, $settJs, $item ) )
				continue;

			$src = HtmlNd::GetAttrVal( $item, 'src' );
			$id = HtmlNd::GetAttrVal( $item, 'id' );
			$srcInfo = GetSrcAttrInfo( $ctxProcess, null, null, $src );

			$detectedPattern = null;
			$isCrit = GetObjSrcCritStatus( $settNonCrit, $specs, $srcInfo, $src, $id, null, $detectedPattern );

			Fullness_AdjustUrl( $ctxProcess, $src, (isset($srcInfo[ 'srcUrlFullness' ])?$srcInfo[ 'srcUrlFullness' ]:null) );
			$item -> setAttribute( 'src', $src );

			if( (isset($ctxProcess[ 'debug' ])?$ctxProcess[ 'debug' ]:null) )
				$item -> setAttribute( 'seraph-accel-debug', 'status=' . ( $isCrit === true ? 'critical' : ( $isCrit === null ? 'special' : 'nonCritical' ) ) . ';' . ( $detectedPattern ? ' detectedPattern="' . $detectedPattern . '"' : '' ) );

			if( $isCrit )
				continue;

			$delay = ( $isCrit === null ) ? $specsDelayTimeout : $notCritsDelayTimeout;
			if( !$delay )
				continue;

			HtmlNd::RenameAttr( $item, 'src', 'data-src' );
			if( $isCrit === null )
			{
				$item -> setAttribute( 'type', 'o/js-lzls' );
				$delaySpecNeeded = true;
			}
			else
			{
				$item -> setAttribute( 'type', 'o/js-lzl' );
				$delayNotCritNeeded = true;
			}
		}
	}

	foreach( $contGroups as $contGroupId => $contGroup )
	{
		if( !$contGroup[ 1 ] )
			continue;

		$item = $doc -> createElement( 'script' );
		if( apply_filters( 'seraph_accel_jscss_addtype', false ) )
			$item -> setAttribute( $item, 'type', 'text/javascript' );

		if( !GetContentProcessorForce( $sett ) && (isset($ctxProcess[ 'chunksEnabled' ])?$ctxProcess[ 'chunksEnabled' ]:null) && Gen::GetArrField( $settCache, array( 'chunks', 'js' ) ) )
		{
			$idSub = ( string )( $ctxProcess[ 'subCurIdx' ]++ ) . '.js';
			$ctxProcess[ 'subs' ][ $idSub ] = $contGroup[ 1 ];
			$src = ContentProcess_GetGetPartUri( $ctxProcess, $idSub );
		}
		else
		{
			$contGroup[ 1 ] = str_replace( ContentMarkGetSep(), '', $contGroup[ 1 ] );
			if( !adkxsshiujqtfk( $ctxProcess, $settCache, 'js', $contGroup[ 1 ], $src ) )
				return( false );
		}

		Cdn_AdjustUrl( $ctxProcess, $settCdn, $src, 'js' );
		Fullness_AdjustUrl( $ctxProcess, $src );
		$item -> setAttribute( 'src', $src );

		if( $contGroupId === 'crit' )
		{
			$head -> insertBefore( $item, $head -> firstChild );
			continue;
		}

		if( $optLoad )
		{
			$delay = ( $contGroupId === 'spec' ) ? $specsDelayTimeout : $notCritsDelayTimeout;
			if( $delay )
			{

				if( $contGroupId === 'spec' )
				{
					$item -> setAttribute( 'type', 'o/js-lzls' );
					$delaySpecNeeded = true;

					$delay = $specsDelayTimeout;
				}
				else
				{
					$item -> setAttribute( 'type', 'o/js-lzl' );
					$delayNotCritNeeded = true;

					$delay = $notCritsDelayTimeout;
				}

				if( (isset($settJs[ 'preLoadEarly' ])?$settJs[ 'preLoadEarly' ]:null) )
					Script_SrcAddPreloading( $item, $src, $head, $doc );
			}
		}

		$body -> appendChild( $item );
	}

	if( $delayNotCritNeeded || $delaySpecNeeded )
	{

		$delayCss = false;
		if( $notCritsDelayTimeout && (isset($ctxProcess[ 'lazyloadStyles' ][ 'nonCrit' ])?$ctxProcess[ 'lazyloadStyles' ][ 'nonCrit' ]:null) === 'withScripts' )
		{
			$delayCss = true;
			unset( $ctxProcess[ 'lazyloadStyles' ][ 'nonCrit' ] );
		}

		if( !adkxsshiujqtfk( $ctxProcess, $settCache, 'js', str_replace( array( '_E_A1_', '_E_A2_', '_E_TM1_', '_E_TM2_', '_E_CSS_', '_E_CJSD_', '_E_FCD_', '_E_PRL_', '_E_LF_' ), array( '"o/js-lzl"', '"o/js-lzls"', $notCritsDelayTimeout ? $notCritsDelayTimeout : 0, $specsDelayTimeout ? $specsDelayTimeout : 0, $delayCss ? $delayCss : 0, (isset($settJs[ 'cplxDelay' ])?$settJs[ 'cplxDelay' ]:null) ? 1 : 0, (isset($settJs[ 'clickDelay' ])?$settJs[ 'clickDelay' ]:null) ? $settJs[ 'clickDelay' ] : 250, (isset($settJs[ 'preLoadEarly' ])?$settJs[ 'preLoadEarly' ]:null) ? 0 : 1, (isset($settJs[ 'loadFast' ])?$settJs[ 'loadFast' ]:null) ? 1 : 0 ),

			"(function(m,f,x,r,p,y,D,E,F,G,H){function z(){if(h){var d=m[function(e){var b=\"\";e.forEach(function(c){b+=String.fromCharCode(c+3)});return b}([103,78,114,98,111,118])];!h.dkhjihyvjed&&d?h=void 0:(h.dkhjihyvjed=!0,h.jydy(d))}}function q(d,e,b){function c(){if(!d)return[];for(var a=[].slice.call(f.querySelectorAll('[type=\"'+d+'\"]')),b=0,l=a.length;b<l;b++){var c=a[b];!c.hasAttribute(\"defer\")||!1===c.defer||c.hasAttribute(\"async\")&&!1!==c.async||!c.hasAttribute(\"src\")||(a.splice(b,1),a.push(c),b--,\nl--)}return a}function a(){z();H?t():setTimeout(t,e)}function A(a){a=a.ownerDocument;var b=a.seraph_accel_njsujyhmaeex={hujvqjdes:\"\",wyheujyhm:a[function(a){var b=\"\";a.forEach(function(a){b+=String.fromCharCode(a+3)});return b}([116,111,102,113,98])],wyhedbujyhm:a[function(a){var b=\"\";a.forEach(function(a){b+=String.fromCharCode(a+3)});return b}([116,111,102,113,98,105,107])],ujyhm:function(a){this.seraph_accel_njsujyhmaeex.hujvqjdes+=a},dbujyhm:function(a){this.write(a+\"\\n\")}};a[function(a){var b=\n\"\";a.forEach(function(a){b+=String.fromCharCode(a+3)});return b}([116,111,102,113,98])]=b.ujyhm;a[function(a){var b=\"\";a.forEach(function(a){b+=String.fromCharCode(a+3)});return b}([116,111,102,113,98,105,107])]=b.dbujyhm}function B(a){var b=a.ownerDocument,c=b.seraph_accel_njsujyhmaeex;if(c){if(c.hujvqjdes){var e=b.createElement(\"span\");a.parentNode.insertBefore(e,a.nextSibling);e.outerHTML=c.hujvqjdes}b[function(a){var b=\"\";a.forEach(function(a){b+=String.fromCharCode(a+3)});return b}([116,111,\n102,113,98])]=c.wyheujyhm;b[function(a){var b=\"\";a.forEach(function(a){b+=String.fromCharCode(a+3)});return b}([116,111,102,113,98,105,107])]=c.wyhedbujyhm;delete b.seraph_accel_njsujyhmaeex}}function t(){var e=u.shift();if(e)if(e.parentNode){var d=f.createElement(e.tagName),l=e.attributes;if(l)for(var g=0;g<l.length;g++){var k=l[g],h=k.value;k=k.name;\"type\"!=k&&(\"data-type\"==k&&(k=\"type\"),\"data-src\"==k&&(k=\"src\"),d.setAttribute(k,h))}d.textContent=e.textContent;l=!d.hasAttribute(\"async\");g=d.hasAttribute(\"src\");\nk=d.hasAttribute(\"nomodule\");l&&A(d);if(g=l&&g&&!k)d.onload=d.onerror=function(){B(d);a()};e.parentNode.replaceChild(d,e);g||(l&&B(d),a())}else u=c(),t();else b&&b()}e=void 0===e?0:e;var u=c();if(G){var g=f.createDocumentFragment();u.forEach(function(a){var b=a?a.getAttribute(\"src\"):void 0;if(b){var c=f.createElement(\"link\");c.setAttribute(\"rel\",\"preload\");c.setAttribute(\"as\",\"IFRAME\"==a.tagName?\"document\":\"script\");c.setAttribute(\"href\",b);a.hasAttribute(\"integrity\")&&c.setAttribute(\"integrity\",\na.getAttribute(\"integrity\"));a.hasAttribute(\"crossorigin\")&&c.setAttribute(\"crossorigin\",a.getAttribute(\"crossorigin\"));g.appendChild(c)}});f.head.appendChild(g)}a()}function g(d,e,b){var c=f.createEvent(\"Events\");c.initEvent(e,!0,!1);if(b)for(var a in b)c[a]=b[a];d.dispatchEvent(c)}function v(d,e){function b(a){try{Object.defineProperty(f,\"readyState\",{configurable:!0,enumerable:!0,value:a})}catch(A){}}function c(a){p?(f.body.className=f.body.className.replace(/(?:^|\\s)seraph-accel-js-lzl-ing(?:\\s|$)/,\n\" \"),h&&(h.jydyut(),h=void 0),b(\"interactive\"),g(f,\"readystatechange\"),g(f,\"DOMContentLoaded\"),delete f.readyState,g(f,\"readystatechange\"),setTimeout(function(){g(m,\"load\");g(m,\"scroll\");e&&e();a()})):a()}n&&(3==n?(D&&function(a,b){a.querySelectorAll(b).forEach(function(a){var b=a.cloneNode();b.rel=\"stylesheet\";a.parentNode.replaceChild(b,a)})}(f,'link[rel=\"stylesheet/lzl-nc\"]'),g(f,\"seraph_accel_beforeJsDelayLoad\"),p&&b(\"loading\"),d?q(p?x:0,10,function(){c(function(){2==n?(n=1,1E6!=y&&setTimeout(function(){v(!0)},\ny)):q(r)})}):q(p?x:0,0,function(){c(function(){q(r)})})):1==n&&q(r),d?n--:n=0)}function C(d){function e(){setTimeout(function(){c.forEach(function(a){if(\"touchend\"==a.type){var b=(a=a.changedTouches&&a.changedTouches.length?a.changedTouches[0]:void 0)?f.elementFromPoint(a.clientX,a.clientY):void 0;b&&(g(b,\"touchstart\",{touches:[{clientX:a.clientX,clientY:a.clientY}]}),g(b,\"touchend\",{touches:[{clientX:a.clientX,clientY:a.clientY}]}))}else\"click\"==a.type&&(b=f.elementFromPoint(a.clientX,a.clientY))&&\ng(b,\"click\",{clientX:a.clientX,clientY:a.clientY})});c=void 0},F)}function b(a){return\"click\"==a||\"touchend\"==a}d.currentTarget&&d.currentTarget.removeEventListener(d.type,C);var c=[];1E6!=p&&setTimeout(function(){v(!0,e)},p);\"scroll wheel mouseenter mousemove mouseover keydown click touchstart touchmove touchend\".split(\" \").forEach(function(a){function d(a){var f=b(a.type);a.currentTarget.removeEventListener(a.type,d,{passive:!f});if(void 0!==c&&f){f=!0;if(\"click\"==a.type)for(var g=a.target;g;g=\ng.parentNode)if(g.getAttribute){g.getAttribute(\"seraph-accel-ncd\")&&(f=!1);var h=g.getAttribute(\"href\");if(\"string\"==typeof h&&0==h.indexOf(\"#elementor-action\")){a.preventDefault();break}}f&&c.push(a)}v(!1,e)}f.addEventListener(a,d,{passive:!b(a)})})}function w(){f.documentElement.style.setProperty(\"--seraph-accel-client-width\",\"\"+f.documentElement.clientWidth+\"px\")}var h=E?{a:[],jydy:function(d){if(d&&d.fn&&!d.seraph_accel_bpb){this.a.push(d);d.seraph_accel_bpb={otquhdv:d.fn[function(d){var b=\"\";\nd.forEach(function(c){b+=String.fromCharCode(c+3)});return b}([111,98,94,97,118])]};if(d[function(d){var b=\"\";d.forEach(function(c){b+=String.fromCharCode(c+3)});return b}([101,108,105,97,79,98,94,97,118])])d[function(d){var b=\"\";d.forEach(function(c){b+=String.fromCharCode(c+3)});return b}([101,108,105,97,79,98,94,97,118])](!0);d.fn[function(d){var b=\"\";d.forEach(function(c){b+=String.fromCharCode(c+3)});return b}([111,98,94,97,118])]=function(e){f.addEventListener(\"DOMContentLoaded\",function(b){e.bind(f)(d,\nb)});return this}}},jydyut:function(){for(var d=0;d<this.a.length;d++){var e=this.a[d];e.fn[function(b){var c=\"\";b.forEach(function(a){c+=String.fromCharCode(a+3)});return c}([111,98,94,97,118])]=e.seraph_accel_bpb.otquhdv;delete e.seraph_accel_bpb;if(e[function(b){var c=\"\";b.forEach(function(a){c+=String.fromCharCode(a+3)});return c}([101,108,105,97,79,98,94,97,118])])e[function(b){var c=\"\";b.forEach(function(a){c+=String.fromCharCode(a+3)});return c}([101,108,105,97,79,98,94,97,118])](!1)}}}:void 0;\nm.seraph_accel_gzjydy=z;var n=3;m.addEventListener(\"load\",C);m.addEventListener(\"resize\",w,!1);f.addEventListener(\"DOMContentLoaded\",w,!1);m.addEventListener(\"load\",w)})(window,document,_E_A1_,_E_A2_,_E_TM1_,_E_TM2_,_E_CSS_,_E_CJSD_,_E_FCD_,_E_PRL_,_E_LF_);\n"
		), $src ) )
			return( false );

		$item = $doc -> createElement( 'script' );
		if( apply_filters( 'seraph_accel_jscss_addtype', false ) )
			$item -> setAttribute( 'type', 'text/javascript' );
		$item -> setAttribute( 'id', 'seraph-accel-js-lzl' );
	    $item -> setAttribute( 'defer', '' );

		Cdn_AdjustUrl( $ctxProcess, $settCdn, $src, 'js' );
		Fullness_AdjustUrl( $ctxProcess, $src );
		$item -> setAttribute( 'src', $src );

		$body -> appendChild( $item );

	}

	return( true );
}

function Scripts_IsElemAs( &$ctxProcess, $doc, $settJs, $item )
{
	$items = &$ctxProcess[ 'scriptsInclItems' ];
	if( $items === null )
	{
		$items = array();

		$incls = Gen::GetArrField( $settJs, array( 'other', 'incl' ), array() );
		if( $incls )
		{
			$xpath = new \DOMXPath( $doc );

			foreach( $incls as $inclItemPath )
				foreach( HtmlNd::ChildrenAsArr( $xpath -> query( $inclItemPath, $ctxProcess[ 'ndHtml' ] ) ) as $itemIncl )
					$items[] = $itemIncl;
		}
	}

	return( in_array( $item, $items, true ) );
}

function JsMinify( $cont, $method, $removeFlaggedComments = false )
{
	try
	{
		switch( $method )
		{
		case 'jshrink':		$contNew = JShrink\Minifier::minify( $cont, array( 'flaggedComments' => !$removeFlaggedComments ) ); break;
		default:			$contNew = JSMin\JSMin::minify( $cont, array( 'removeFlaggedComments' => $removeFlaggedComments ) ); break;
		}
	}
	catch( \Exception $e )
	{
		return( $cont );
	}

	if( !$contNew )
		return( $cont );

	$cont = $contNew;

	if( (isset($ctxProcess[ 'debug' ])?$ctxProcess[ 'debug' ]:null) )
		$cont = '/* DEBUG: MINIFIED by seraph-accel */' . $cont;

	return( $cont );
}

function Script_AdjustCont( $ctxProcess, $settCache, $settJs, $srcInfo, $src, $id, &$cont )
{
	if( !$cont )
		return( false );

	$adjusted = false;
	if( ( !$srcInfo || !(isset($srcInfo[ 'ext' ])?$srcInfo[ 'ext' ]:null) ) && Gen::GetArrField( $settJs, array( 'min' ), false ) && !IsObjInRegexpList( Gen::GetArrField( $settJs, array( 'minExcls' ), array() ), $src, $id, $cont ) )
	{
		$contNew = trim( JsMinify( $cont, (isset($settJs[ 'minMthd' ])?$settJs[ 'minMthd' ]:null), (isset($settJs[ 'cprRem' ])?$settJs[ 'cprRem' ]:null) ) );
		if( $cont != $contNew )
		{
			$cont = $contNew;
			$adjusted = true;
		}
	}

	return( $adjusted );
}

